Bug 1094424 - "Reindex Data Tables Nightly" setting can cause agents to time out during reindex
Summary: "Reindex Data Tables Nightly" setting can cause agents to time out during rei...
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: RHQ Project
Classification: Other
Component: Configuration, Performance
Version: 4.9
Hardware: Unspecified
OS: Unspecified
high
high vote
Target Milestone: GA
: RHQ 4.12
Assignee: Jay Shaughnessy
QA Contact: Mike Foley
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-05-05 16:15 UTC by Elias Ross
Modified: 2014-12-15 11:35 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-12-15 11:35:50 UTC


Attachments (Terms of Use)

Description Elias Ross 2014-05-05 16:15:04 UTC
Description of problem:

The "Reindex Data Tables Nightly" option on large tables has caused daily trouble, until I discovered how to turn it off.

modules/enterprise/server/jar/src/main/java/org/rhq/enterprise/server/system/SystemManagerBean.java

Runs:

ALTER INDEX {0} REBUILD UNRECOVERABLE

When being run on Oracle, this prevents inserts while the rebuild takes place, which may be several minutes. This has caused agents to time out and false alerts to be generated.

Unrecoverable is not a good idea as it locks the table during the calculation:
https://community.oracle.com/thread/1103546?tstart=0

The default should be false, as well UNRECOVERABLE is not a good idea either on Oracle because of the locking.

Comment 1 Elias Ross 2014-05-05 16:19:01 UTC
The primary trouble is with the traits table, although I suspect the availability table may also cause trouble during reindex.

Comment 2 Jay Shaughnessy 2014-07-01 15:50:56 UTC
Merged PR45

master commit 78541021d881c60dd97e3b21e0af1b0d59cc84ad
Merge: ba0c4d3 537c51f
Author: jshaughn <jshaughn@redhat.com>
Date:   Tue Jul 1 10:19:50 2014 -0400

    Merge pull request #45 from genman/BZ1094424

    BZ1094424 - do not reindex tables by default; don't use UNRECOVERABLE


Some more follow up work coming...

Comment 3 Jay Shaughnessy 2014-07-01 17:06:55 UTC
master commit a68c656eca8f0574dd551a6faf51a0df829f0f39
Author: Jay Shaughnessy <jshaughn@redhat.com>
Date:   Tue Jul 1 13:05:39 2014 -0400

    [1094424] "Reindex Data Tables Nightly" setting can cause agents to time
    This is follow-up work to PR45.  Add setting the nightly re-index option
    to false in db-upgrade.  Also, remove unused numeric data tables from
    being processed if in fact the option is set to true.

    This whole option should probably go away, see the discussion in the
    PR.

Comment 4 Heiko W. Rupp 2014-12-15 11:35:50 UTC
Bulk close of items fixed in RHQ 4.12

If you think this is not solved, then please open a *new* BZ and link to this one.


Note You need to log in before you can comment on or make changes to this bug.